<?php

namespace Drupal\mcapi_cc\CreditCommons;

use Drupal\mcapi_cc\TrunkwardNodeRequester;
use CreditCommons\AccountRemote;
use CreditCommons\Transaction;
use Drupal\mcapi\Entity\Wallet;

/**
 * These account objects are needed to use the \CreditCommons\Entry class.
 */
class TrunkwardAccount extends AccountRemote {

  protected $url;
  protected $min;
  protected $max;
  protected $period;

  function __construct(string $rel_path = '') {
    $config = \Drupal::config('mcapi_cc.settings');
    $wallet = Wallet::load($config->get('wallet_id'));
    parent::__construct($config->get('trunkward.id'), $rel_path);
    $this->min = $wallet->min->limit();
    $this->max = $wallet->max->limit();
    $this->period = 0;
    $this->url = $config->get('trunkward.url');
  }

  function getRequester() : TrunkwardNodeRequester {
    return \Drupal::service('mcapi_cc.trunkward_node');
  }

  /**
   * {@inheritdoc}
   * @todo
   */
  function storeHash(Transaction $transaction) {

  }

  function getLimits($force_local = false): \stdClass|array {

  }
  function getSummary($force_local = false): \stdClass|array {


  }
  function authenticate(string $string) {

  }
  function leafwardPath() : string {

  }

  function getUrl() : string {
    return $this->url;
  }


  /**
   * Must return the absolute path of the account
   */
  function __toString() {
    return $this->relPath;
  }

}